{ El archivo TUR5BTRV.TPU es la interface con Btrieve.
  Este  programa  requiere en el  mismo directorio  el
  archivo ALUM_PAS.BTR.                                }

program btrv_PAS (input, output);

uses crt,tur5btrv,printer;

label
  fin_altas,fin_consulta,fin_bajas,fin_cambios;

const
abrir   =0; cerrar =1; insert =2; restau  =28; consulti =5; borrar  =4;
actualiz=3; c_mayor=8; c_sigui=6; c_primer=12; bloqueo=200; desbloq=27;

var

{ El tamao real de una cadena en Turbo pascal es su dimensin + uno.
Ya que ocupa un byte para contar el nmero de caracteres en la cadena.
Este byte de control ser grabado junto con los datos en el archivo.}

   al : record
      reg: integer;
      cta: string[10];
      nom: string[40];
      dir: string[40];
      col: string[35];
      del: string[25];
      est: string[25];
      tel: string[16];
      gen: string[05];
      sem: integer;
end;

{El largo total del registro es de 208}

archivo,r,rr:string;
tit:array[1..2] of string;

op,rc:char;
cero:integer;

buf_llave:string[40];
llave34:record
             sem:integer;
             lla:string[40];
end;

i,n,k,j,sem,orden,lr,lc,pag,cc:integer;
ib,nb,jb:byte;
camb:boolean;

no_llave,st,lar_buffer:integer;
nada:string;

pos:array[1..128] of char;

function stri(n:byte;c:char):string;
var
i:integer;
cad:string;
begin
cad:='';
for i:=1 to n do cad:=cad+c;
stri:=cad;
end;
procedure pausa;
begin
gotoxy(1,23);
write('PULSE [ENTER] PARA CONTINUAR ...');
readln;
gotoxy(1,23);write(stri(80,' '));
end;

procedure error_halt(st:integer);
begin
  gotoxy(1,24);
  write(#7,'ERROR DE BTRIEVE No. ',st:4,' PULSE ENTER PARA CONTINUAR.');
  readln;
  if st<>20 then st:=BTRV(restau,nada,nada,cero,nada,0);
  halt(0);
end;

procedure centra(y:integer;r:string);
begin
if y<=0 then y:=wherey;
gotoxy(40-length(r) div 2,y);
write(r);
end;

procedure color(x,y:byte);
begin
textcolor(x);
textbackground(y);
end;

procedure encabezado(rr:string);
begin
clrscr;
centra(1,'PROGRAMA MUESTRA, TRABAJA UTILIZANDO EL MANEJADOR DE BASES DE DATOS DE BTRIEVE');
centra(2,'AGENDA DE ALUMNOS DE M.A.C., EN TURBO PASCAL V5.0');
gotoxy(1,3);write(stri(80,'-'));
color(0,7);centra(3,rr);color(7,0);
end;

procedure pone_preg;
begin
gotoxy(1,6);
writeln('[1] CUENTA    :[',stri(10,' '),']');
writeln('[2] NOMBRE    :[',stri(40,' '),']');
writeln('[3] DIRECCION :[',stri(40,' '),']');
writeln('[4] COLONIA   :[',stri(35,' '),']');
writeln('[5] DEL O CIU :[',stri(25,' '),']');
writeln('[6] ESTADO    :[',stri(25,' '),']');
writeln('[7] TELEFONOS :[',stri(16,' '),']');
writeln('[8] GENERACION:[',stri(05,' '),']');
writeln('[9] SEMESTRE  :[',stri(02,' '),']');
end;

procedure pone_datos;
begin
gotoxy(17, 6);writeln(al.cta);
gotoxy(17, 7);writeln(al.nom);
gotoxy(17, 8);writeln(al.dir);
gotoxy(17, 9);writeln(al.col);
gotoxy(17,10);writeln(al.del);
gotoxy(17,11);writeln(al.est);
gotoxy(17,12);writeln(al.tel);
gotoxy(17,13);writeln(al.gen);
gotoxy(17,14);writeln(al.sem);
gotoxy(60, 4);writeln('REGISTRO: [',al.reg:5,']');
end;
{***************** inicio del programa principal *********************}
begin

tit[1]:='REG   CUENTA     NOMBRE DEL ALUMNO                        TELEFONO        SEM';
tit[2]:='REG   NOMBRE DEL ALUMNO                        CUENTA     TELEFONO        SEM';
nada:='';

{Apertura del archivo}
clrscr;
lar_buffer:=208;
no_llave:=0;
archivo:='ALUM_PAS.BTR ';
st:=BTRV(abrir,pos,nada,lar_buffer,archivo[1],0);
if st<>0 then error_halt(st);

{menu}
repeat
encabezado('MENU');
repeat
 gotoxy(1,23);
 color(0,7);
 write('1)ALTAS 2)BAJAS 3)CAMBIOS 4)CONSULTAS 5)CONS. X SEM. 6)CATALOGO 7)FIN =>');
 color(7,0);
 readln(op);
until (op>='1') and (op<='7');

case op of
       {****************** A L T A S *******************}
   '1':begin
       repeat
       rc:='x';
       encabezado('ALTAS');
       pone_preg;

       repeat
       gotoxy(17, 6);readln(al.cta);if al.cta='' then goto fin_altas;
       until length(al.cta)>=9;
       repeat
       gotoxy(17, 7);readln(al.nom);if al.nom='' then goto fin_altas;
       until length(al.nom)>10;
       gotoxy(17, 8);readln(al.dir);
       gotoxy(17, 9);readln(al.col);
       gotoxy(17,10);readln(al.del);
       gotoxy(17,11);readln(al.est);
       gotoxy(17,12);readln(al.tel);
       gotoxy(17,13);readln(al.gen);

       repeat
       gotoxy(17,14);readln(r);val(r,al.sem,i);
       until (al.sem>=1) and (al.sem<=15);
       repeat
       gotoxy(1,23);
       write('DESEA DAR DE ALTA ESTOS DATOS (S o N)?');
       readln(rc);rc:=upcase(rc);
       until (rc='N') or (rc='S');
       if rc='S' then
       begin
         al.reg:=0;
         lar_buffer:=208;
         no_llave:=0;
         st:=BTRV(insert,pos,al,lar_buffer,al.reg,no_llave);
         if (st=5) then
         begin
            gotoxy(1,23);
            write('EL NOMBRE Y/O LA CUENTA YA EXISTEN. ALTA INVALIDA...',#7);
            readln;
         end else
            if st<>0 then error_halt(st);
       end;{if}
       fin_altas:;
       until (rc='x');
       end;
       {******************* B A J A S *****************}
    '2':begin
        repeat {bajas}
        repeat {pregunta}
        rc:='x';
        encabezado('BAJAS');
        pone_preg;
        gotoxy(1,5);write('NOMBRE, CTA o REG:[',STRI(40,' '),']');
        gotoxy(20,5);
        readln(r);
        lr:=length(r);
        until lr<=40;
        if r='' then goto fin_bajas;
        no_llave:=0;
        if lr<=5 then begin
                       no_llave:=0;
                       val(r,i,n);
                       move(i,r,2);
                      end else
                      if lr<=10 then no_llave:=1
                                     else
                                       no_llave:=2;

         lar_buffer:=208;
         st:=BTRV(consulti+bloqueo,pos,al,lar_buffer,r,no_llave);
         r:='';
         if (st=84) then
         begin
          gotoxy(1,23);
          write('REGISTRO BLOQUEADO POR OTRA COMPUTADORA DE LA RED. Pulse [Enter].',#7);
          readln;rc:=' ';
         end else
         if (st=4) then
         begin
            gotoxy(1,23);
            write('NO SE ENCONTRO EL ALUMNO, PULSE [ENTER] P. CONT.',#7);
            readln;rc:=' ';
         end else
            if st<>0 then error_halt(st)
       else begin
         pone_datos;
         rc:='S';
         repeat
         gotoxy(1,23);
         write('DESEA DARLO DE BAJA (S o N)?');
         readln(rc);rc:=upcase(rc);
         until (rc='N') or (rc='S');
       end;
        if rc='N' then
        begin
        lar_buffer:=208;
        st:=BTRV(desbloq,pos,al,lar_buffer,nada,no_llave);
        end
         else st:=BTRV(borrar,pos,al,cero,nada,cero);

        fin_bajas:;
        until rc='x';
        end; {bajas}


       {******************* C A M B I O S *****************}
    '3':begin
        repeat {consultas}
        camb:=false;
        repeat {pregunta}
        rc:='x';
        encabezado('CAMBIOS');
        pone_preg;
        gotoxy(1,5);write('NOMBRE, CTA o REG:[',STRI(40,' '),']');
        gotoxy(20,5);
        readln(r);
        lr:=length(r);
        until lr<=40;
        if r='' then goto fin_cambios;
        buf_llave:=r;
        no_llave:=0;
        if lr<=5 then begin
                       no_llave:=0;
                       val(buf_llave,i,n);
                       move(i,buf_llave,2);
                      end else
                      if lr<=10 then no_llave:=1
                                     else
                                       no_llave:=2;

         lar_buffer:=208;
         st:=BTRV(consulti+bloqueo,pos,al,lar_buffer,buf_llave,no_llave);

         if (st=4) then
         begin
            gotoxy(1,23);
            write('NO SE ENCONTRO EL ALUMNO, PULSE [ENTER] P. CONT.',#7);
            readln;rc:=' ';
         end else
            if st<>0 then error_halt(st)
       else begin
         pone_datos;
         repeat
         repeat
         gotoxy(1,23);
         write('ESTA CORRECTA LA INFORMACION (S o N)?');
         readln(rc);rc:=upcase(rc);
         until (rc='N') or (rc='S');
         if rc='N' then
         begin
           repeat
           repeat
            gotoxy(1,23);write(stri(79,' '));
            gotoxy(1,23);
            write('No. DE DATO A MODIFICAR:');readln(r);
            val(r,cc,i);
           until (cc>=0) and (cc<=9);
           if cc>0 then camb:=true;
           case cc of
           1:begin
              repeat
              gotoxy(17, 6);write(stri(10,' '));
              gotoxy(17, 6);readln(al.cta);
              until length(al.cta)>=9;
             end;
           2:begin
              repeat
              gotoxy(17, 7);write(stri(40,' '));
              gotoxy(17, 7);readln(al.nom);
              until length(al.nom)>10;
             end;
            3:begin
               gotoxy(17, 8);write(stri(40,' '));
               gotoxy(17, 8);readln(al.dir);
              end;
            4:begin
               gotoxy(17, 9);write(stri(35,' '));
               gotoxy(17, 9);readln(al.col);
              end;
            5:begin
               gotoxy(17,10);write(stri(25,' '));
               gotoxy(17,10);readln(al.del);
              end;
            6:begin
              gotoxy(17,11);write(stri(25,' '));
              gotoxy(17,11);readln(al.est);
              end;
            7:begin
              gotoxy(17,12);write(stri(16,' '));
              gotoxy(17,12);readln(al.tel);
              end;
            8:begin
              gotoxy(17,13);write(stri(15,' '));
              gotoxy(17,13);readln(al.gen);
              end;
            9:begin
              repeat
               gotoxy(17,14);write(stri(2,' '));
               gotoxy(17,14);readln(r);val(r,al.sem,i);
              until (al.sem>=1) and (al.sem<=15);
              end;
           end; {case}
        until cc=0;
        end;
        until rc='S';
       end;

        fin_cambios:;
        until (rc='S') or (rc='x');
        if camb then
         begin   { ACTUALIZA EL REGISTRO }
          lar_buffer:=208;
          st:=BTRV(actualiz,pos,al,lar_buffer,buf_llave,no_llave);
          if st<>0 then error_halt(st);
         end else
             begin
              lar_buffer:=208;
              st:=BTRV(desbloq,pos,al,lar_buffer,nada,no_llave);
             end;
        end; {cambios}

       {******************* C O N S U L T A S *****************}
    '4':begin
        repeat {consultas}
        repeat {pregunta}
        rc:='x';
        encabezado('CONSULTAS');
        pone_preg;
        gotoxy(1,5);write('NOMBRE, CTA o REG:[',STRI(40,' '),']');
        gotoxy(20,5);
        readln(r);
        lr:=length(r);
        until lr<=40;
        if r='' then goto fin_consulta;
        no_llave:=0;
        if lr<=5 then begin
                       no_llave:=0;
                       val(r,i,n);
                       move(i,r,2);
                      end else
                      if lr<=10 then no_llave:=1
                                     else
                                       no_llave:=2;

        lar_buffer:=208;
         st:=BTRV(consulti,pos,al,lar_buffer,r,no_llave);
         r:='';
         if (st=4) then
         begin
            gotoxy(1,23);
            write('NO SE ENCONTRO EL ALUMNO, PULSE [ENTER] P. CONT.',#7);
            readln;
            rc:=' ';
         end else
            if st<>0 then error_halt(st)
       else begin
         pone_datos;
         rc:='S';
         repeat
         gotoxy(1,23);
         write('DESEA SEGUIR CONSULTANDO (S o N)?');
         readln(rc);rc:=upcase(rc);
       until (rc='N') or (rc='S');
      end;
        fin_consulta:;

        until (rc='N') or (rc='x');
        end; {consultas}

        { ******************* CONSULTA POR SEM ****************}
    '5':begin
        repeat
        rr:='CONSULTA EN PANTALLA POR SEMESTRE/CUENTA o SEMESTRE/NOMBRE';
        encabezado(rr);
        repeat
         gotoxy(1,10);write('INDIQUE EL SEMESTRE A CONSULTAR:');
         readln(r);

         val(r,sem,i);
        until (r='') or ((sem>1) and (sem<15));
        if r<>'' then
        begin
        repeat
         gotoxy(1,11);
         write('1]CUENTA  O   2]NOMBRE  (1 o 2)?');
         readln(r);
         val(r,orden,i);
        until (orden=1) or (orden=2);
        encabezado(rr);
        gotoxy(1,5);
        writeln(tit[orden]);
        writeln(stri(80,'-'));

        llave34.sem:=sem;llave34.lla:='';
        lar_buffer:=208;no_llave:=2+orden;
        st:=BTRV(c_mayor,pos,al,lar_buffer,llave34,no_llave);

        if (st=9) or (st=4) or (al.sem<>sem) then
         begin
          gotoxy(1,23);
          write('NO EXISTEN ALUMNOS EN EL SEMESTRE INDICADO ...',#7);
          readln;
         end
         else
         begin
         if st<>0 then error_halt(st);
                if orden=1 then writeln(al.reg:5,' ',al.cta:10,' ',al.nom:40,' ',al.tel:16,' ',al.sem)
                   else writeln(al.reg:5,' ',al.nom:40,' ',al.cta:10,' ',al.tel:16,' ',al.sem);
         n:=7;

         while (st=0) and (al.sem=sem) do
         begin
          lar_buffer:=208;
          st:=BTRV(c_sigui,pos,al,lar_buffer,llave34,no_llave);
          if (st<>0) and (st<>9) and (st<>4) then error_halt(st);

          if ((st=0) and (al.sem=sem)) then
          begin
                  if orden=1 then writeln(al.reg:5,' ',al.cta:10,' ',al.nom:40,' ',al.tel:16,' ',al.sem)
                     else writeln(al.reg:5,' ',al.nom:40,' ',al.cta:10,' ',al.tel:16,' ',al.sem);
          n:=n+1;if n=21 then begin
                               pausa;
                               for ib:=7 to 21 do begin
                               gotoxy(1,ib);write(stri(80,' '));
                               n:=7;gotoxy(1,7);
                              end;
          end;

         end  {if}
        end; pausa; {while}
        r:='x';
        end; {else}
        end; {if}
        until r='';
        end; {case}

        {***************** CATALOGOS IMPRESOS *****************}
    '6':begin
        rr:='CATALOGOS IMPRESOS';
        encabezado(rr);
        repeat
        gotoxy(1,7);
        writeln('1) POR REGISTRO');
        writeln('2) POR CUENTA');
        writeln('3) POR NOMBRE');
        writeln('4) POR SEMESTRE/CUENTA');
        writeln('5) POR SEMESTRE/NOMBRE');
          write('   OPCION ==>');readln(r);
        val(r,orden,i);
        until (orden>=0) and (orden<=5);
        if orden<>0 then
        begin
          encabezado(rr);
          repeat
           gotoxy(1,23);
           write('ESTA LISTA SU IMPRESORA (S o N)?');
           readln(rc);rc:=upcase(rc);
          until (rc='N') or (rc='S');
          if rc='S' then
          begin
           lc:=0;pag:=0;
           gotoxy(1,23);write('IMPRESION EN PROCESO ...         ');

           lar_buffer:=208;no_llave:=orden-1;r:=stri(40,' ');
           st:=BTRV(c_primer,pos,al,lar_buffer,r,no_llave);

           while st=0 do
           begin
             if (lc=0) or (lc>=60) then
                begin
                  if lc>=60 then
                  begin
                     writeln(lst,#12);lc:=0;
                  end;
                  r:= 'Programa Muestra, Trabaja Utilizando el Manejador de Bases de Datos de BTRIEVE';
                  writeln(lst,stri(40-length(r) div 2,' '),r);
                  r:='AGENDA DE ALUMNOS DE M.A.C., EN TURBO PASCAL V5.0';
                  writeln(lst,stri(40-length(r) div 2,' '),r);
                  if orden=1 then rr:='No. DE REGISTRO';
                  if orden=2 then rr:='No. DE CUENTA';
                  if orden=3 then rr:='NOMBRE';
                  if orden=4 then rr:='No. DE SEMESTRE Y CUENTA';
                  if orden=5 then rr:='No. DE SEMESTRE Y NOMBRE';
                  rr:='REPORTE ORDENADO POR '+rr;
                  writeln(lst,stri(40-length(rr) div 2,' '),rr);
                  pag:=pag+1;writeln(lst,'PAG:[',pag:3,']');
                  writeln(lst,stri(80,'-'));
                  writeln(lst,'  REG CUENTA     NOMBRE                               SEM GEN   TELEFONO');
                  writeln(lst,stri(80,'-'));
                  LC:=7;
                end; {if}
                    writeln(lst,al.reg:5,' ',al.cta:10,' ',al.nom:37,' ',al.sem:2,' ',al.gen:5,' ',al.tel:16);
           lc:=lc+1;
           lar_buffer:=208;
           st:=BTRV(c_sigui,pos,al,lar_buffer,r,no_llave);
           end; {while}
           if lc>0 then writeln(lst,#12);
          end; {esta lista su imp.}
        end;   {if}
        end;   {catalogo}
 end;{case}
until (op='7');

{***************** FIN DEL PROGRAMA *****************}

st:=BTRV(cerrar,pos,nada,cero,nada,0);
clrscr;
end.

