/* EL ARCHIVO turcbtrv.c ES LA INTERFACE CON BTRIEVE */
# include "turcbtrv.c"

# include "stdio.h"
# include "conio.h"

const
abrir   =0, cerrar =1, insert =2, restau  =28, consulti =5, borrar  =4,
actualiz=3, c_mayor=8, c_sigui=6, c_primer=12, bloqueo=200, desbloq=27,
true   =-1, false  =0, cero   =0;

/* SE ADICIONA UN CHARACTER A TODAS LAS CADENAS PARA GRABAR EN EL ARCHIVO
   EL IDENTIFICADOR DE FIN DE CADENA */
struct regis
{
int  reg;
char cta[10+1];
char nom[40+1];
char dir[40+1];
char col[35+1];
char del[25+1];
char est[25+1];
char tel[16+1];
char gen[05+1];
int  sem;
} al;

char archivo[256],r[256],rr[256],rc;
char tit[256][2];

char op,rc;

char buf_llave[40+1];

struct segment{
       int sem;
       char lla[40+1];
} llave34;

int i,n,k,j,seme,orden,lr,lc,pag,cc;
char ib,nb,jb,camb;

int no_llave,st,lar_buffer;

char nada[128];

char pos[128];


main()
{

strcpy(tit[1],"REG   CUENTA     NOMBRE DEL ALUMNO                        TELEFONO        SEM");
strcpy(tit[2],"REG   NOMBRE DEL ALUMNO                        CUENTA     TELEFONO        SEM");


/* APERTURA DEL ARCHIVO */
clrscr();
nada[0]=0;

lar_buffer=208;
no_llave=0;
strcpy(archivo,"ALUM_C.BTR");
st = BTRV(abrir,pos,nada,&lar_buffer,archivo,0);
if (st!=0) error_exit();

/* MENU */
menu:
encabezado("MENU");
do {
 gotoxy(1,23);
 color(0,7);
 cputs("1)ALTAS 2)BAJAS 3)CAMBIOS 4)CONSULTAS 5)CONS. X SEM. 6)CATALOGO 7)FIN =>");
 color(7,0);
 op=getche();
} while (!(op>='1' && op<='7'));

switch (op) {

case '1': altas:
	  encabezado("ALTAS");
	  pone_preg();

	  do {
	     gotoxy(17, 6);gets(al.cta);
	  }while (strlen(al.cta)<9 && al.cta[0]!=0);
	  if (al.cta[0]==0) break; /* SALIDA DE ALTAS */
	  do{
	    gotoxy(17, 7);gets(al.nom);
	  }while (strlen(al.nom)<10 && al.nom[0]!=0);
	  if (al.nom[0]==0) break; /* SALIDA DE ALTAS */
	  gotoxy(17, 8);gets(al.dir);
	  gotoxy(17, 9);gets(al.col);
	  gotoxy(17,10);gets(al.del);
	  gotoxy(17,11);gets(al.est);
	  gotoxy(17,12);gets(al.tel);
	  gotoxy(17,13);gets(al.gen);
	  do {
	     gotoxy(17,14);cscanf("%d",&al.sem);
	  }while ((al.sem<1 || al.sem>15));

	  do {
	     gotoxy(1,23);
	     cputs("DESEA DAR DE ALTA ESTOS DATOS (S o N)?");
	     rc=getche();rc=upcase(rc);
	  }while (rc!='N' && rc!='S');
	  if (rc=='N') goto altas;

	  /* INSERTA EL REGISTRO */
	  al.reg=0;
	  lar_buffer=208;
	  no_llave=0;
	  st=BTRV(insert,pos,&al,&lar_buffer,&al.reg,no_llave);
	  if (st==5) {
	     gotoxy(1,23);
	     cputs("EL NOMBRE Y/O LA CUENTA YA EXISTEN. ALTA INVALIDA...");
	     putch(7); /* BBEP */
	     rc=getch();
	  } else
	     if (st!=0) error_exit(st);
	  goto altas;

case '2': bajas:
	  do {
	     encabezado("BAJAS");
	     pone_preg();
	     gotoxy(1,5);cprintf("NOMBRE, CTA o REG:[%40s]","");
	     gotoxy(20,5);
	     gets(r);
	     lr=strlen(r);
	  }while (lr>40);
	  if (r[0]==0) break; /* SALIDA DE BAJAS */
	  no_llave=0;

	  if (lr<=5) {no_llave=0;
		      i=atoi(r);
		      r[0]=*(&i); /*COLOCA EL VALOR DEL ENTERO EN LA CADENA*/
		      r[1]=*(&i+1);
		      } else
			 if (lr<=10) no_llave=1;
			else
			 no_llave=2;

	  lar_buffer=208;/* CONSULA Y BLOQUEA (SIN ESPERA) */
	  st=BTRV(consulti+bloqueo,pos,&al,&lar_buffer,r,no_llave);
	  r[0]=0;

	  if (st==84) {
	     gotoxy(1,23);
	     cputs("REGISTRO BLOQUEADO POR OTRA COMPUTADORA DE LA RED. PULSE [ENTER].");
	     putch(7);
	     rc=getch();
	  } else
	     if (st==4){
		gotoxy(1,23);
		cputs("NO SE ENCONTRO EL ALUMNO, PULSE [ENTER] P. CONT.");
		putch(7);
		rc=getch();
	     } else
		if (st!=0) error_exit(st);
		   else {
		    pone_datos();
		    do {gotoxy(1,23);
		       cputs("DESEA DARLO DE BAJA (S o N)?");
		       rc=getche();rc=upcase(rc);
		    }while (rc!='N' && rc!='S');

		    if (rc=='N') {
		    lar_buffer=208;
		    st=BTRV(desbloq,pos,&al,&lar_buffer,nada,no_llave);
		    } else st=BTRV(borrar,pos,&al,&cero,nada,cero);
		   }
	  goto bajas;

case '3': cambios:
	  camb=false;
	  do {
	     encabezado("CAMBIOS");
	     pone_preg();
	     gotoxy(1,5);cprintf("NOMBRE, CTA o REG:[%40s]","");
	     gotoxy(20,5);
	     gets(r);
	     lr=strlen(r);
	  }while (lr>40);
	  if (r[0]==0) break; /* SALIDA DE CAMBIOS */
	  no_llave=0;
	  strcpy(buf_llave,r);
	  if (lr<=5) {no_llave=0;
		      i=atoi(buf_llave);
		      buf_llave[0]=*(&i);
		      buf_llave[1]=*(&i+1);
		      } else
			 if (lr<=10) no_llave=1;
			 else
			  no_llave=2;

	  lar_buffer=208;
	  st=BTRV(consulti+bloqueo,pos,&al,&lar_buffer,buf_llave,no_llave);
	  if (st==84) {
	     gotoxy(1,23);
	     cputs("REGISTRO BLOQUEADO POR OTRA COMPUTADORA DE LA RED. PULSE [ENTER].");
	     putch(7);
	     rc=getch();
	  } else
	     if (st==4) {
		gotoxy(1,23);
		cputs("NO SE ENCONTRO EL ALUMNO, PULSE [ENTER] P. CONT.");
		putch(7);
		rc=getch();
	     } else
		if (st!=0) error_exit(st);
		 else {
		  pone_datos();
		  do {
		     do {
			 gotoxy(1,23);
			 cputs("ESTA CORRECTA LA INFORMACION (S o N)?");
			 rc=getche();rc=upcase(rc);
		     }while (rc!='N' && rc!='S');

		     if (rc=='N') do {
			gotoxy(1,23);stri(79,' ');
			gotoxy(1,23);
			cputs("No. DE DATO A MODIFICAR:");rc=getche();
			cc=rc-48;if (cc<0) cc=0;
		     if (cc>0) camb=true;

		     switch (cc) {
		     case 1: do {
			       gotoxy(17, 6);stri(10,' ');
			       gotoxy(17, 6);gets(al.cta);
			     } while (strlen(al.cta)<9);
			     break;

		     case 2: do {
			       gotoxy(17, 7);stri(40,' ');
			       gotoxy(17, 7);gets(al.nom);
			     }while (strlen(al.nom)<=10);
			     break;

		     case 3: gotoxy(17, 8);stri(40,' ');
			     gotoxy(17, 8);gets(al.dir);
			     break;

		     case 4: gotoxy(17, 9);stri(35,' ');
			     gotoxy(17, 9);gets(al.col);
			     break;

		     case 5: gotoxy(17,10);stri(25,' ');
			     gotoxy(17,10);gets(al.del);
			     break;

		     case 6: gotoxy(17,11);stri(25,' ');
			     gotoxy(17,11);gets(al.est);
			     break;

		     case 7: gotoxy(17,12);stri(16,' ');
			     gotoxy(17,12);gets(al.tel);
			     break;

		     case 8: gotoxy(17,13);stri(15,' ');
			     gotoxy(17,13);gets(al.gen);
			     break;

		     case 9: do {
				gotoxy(17,14);stri(2,' ');
				gotoxy(17,14);gets(r);al.sem=atoi(r);
			     } while(al.sem<1 && al.sem>15);
			     break;
		     } /*switch*/
		  } while (cc>0);
	     } while (rc!='S');
	   } /* else */

	  if (camb) {
	     lar_buffer=208;
	     st=BTRV(actualiz,pos,&al,&lar_buffer,buf_llave,no_llave);
	     if (st!=0) error_exit(st);
	  } else {
	     lar_buffer=208;
	     st=BTRV(desbloq,pos,&al,&lar_buffer,nada,no_llave);
	     }
	  goto cambios;

case '4': consulta:
	  do {
	     encabezado("CONSULTAS");
	     pone_preg();
	     gotoxy(1,5);cprintf("NOMBRE, CTA o REG:[%40s]","");
	     gotoxy(20,5);
	     gets(r);lr=strlen(r);
	  }while (lr>40);
	  if (r[0]==0) break; /* SALIDA DE CONSULTA */

	  no_llave=0;
	  if (lr<=5) {no_llave=0;
		      i=atoi(r);
		      r[0]=*(&i);
		      r[1]=*(&i+1);
		      } else
			 if (lr<=10) no_llave=1;
			 else
			  no_llave=2;

	  lar_buffer=208;
	  st=BTRV(consulti,pos,&al,&lar_buffer,r,no_llave);
	  r[0]=0;
	  rc='N'; /* no se desea seuir consultando */
	  if (st==4) {
	     gotoxy(1,23);
	     cprintf("%s","NO SE ENCONTRO EL ALUMNO, PULSE [ENTER] P. CONT.");
	     putch(7);
	     rc=getch();
	     } else if (st!=0) error_exit();
		    else {
		     pone_datos();
		      do {
			 gotoxy(1,23);
			 cputs("DESEA SEGUIR CONSULTANDO (S o N)?");
			 rc=getche();rc=upcase(rc);
		      }while (rc!='N' && rc!='S');
		    } /* else */

	  if (rc=='S') goto consulta;
	  break; /* SALIDA DE CONSULTA */

case '5': consultas:
	  strcpy(rr,"CONSULTA EN PANTALLA POR SEMESTRE/CUENTA o SEMESTRE/NOMBRE");
	  encabezado(rr);
	  do {
	     gotoxy(1,10);cputs("INDIQUE EL SEMESTRE A CONSULTAR:");
	     gets(r);
	     seme=atoi(r);
	  }while (seme<0 || seme>15);
	  if (seme==0) break;
	  do {
	     gotoxy(1,11);
	     cputs("1]CUENTA  O   2]NOMBRE  (1 o 2)?");
	     gets(r);orden=atoi(r);
	  }while (orden<1 || orden>2);

	  encabezado(rr);
	  gotoxy(1,5);
	  cputs(tit[orden]);gotoxy(1,6);
	  stri(80,'-');

	  /* USO DE LAS LLAVES SEGMENTADAS */
	  llave34.sem=seme;llave34.lla[0]=0;
	  lar_buffer=208;no_llave=2+orden;
	  st=BTRV(c_mayor,pos,&al,&lar_buffer,&llave34,no_llave);

	  if (st==9 || st==4 || al.sem!=seme) {
	     gotoxy(1,23);
	     cputs("NO EXISTEN ALUMNOS EN EL SEMESTRE INDICADO ...");
	     putch(7);
	     rc=getch();
	  }
	  else {
	   if (st!=0) error_exit();
	   if (orden==1) cprintf("%5d %-10s %-40s %-16s %2d\r\n",al.reg,al.cta,al.nom,al.tel,al.sem);
	      else cprintf("%5d %-40s %-10s %-16s %2d\r\n",al.reg,al.nom,al.cta,al.tel,al.sem);
	   n=7;
	   while (st==0 && al.sem==seme) {
	     lar_buffer=208;
	     st=BTRV(c_sigui,pos,&al,&lar_buffer,&llave34,no_llave);
	     if (st!=0 && st!=9 && st!=4) error_exit();
	     if (st==0 && al.sem==seme) {
		if (orden==1) cprintf("%5d %-10s %-40s %-16s %2d\r\n",al.reg,al.cta,al.nom,al.tel,al.sem);
		 else cprintf("%5d %-40s %-10s %-16s %2d\r\n",al.reg,al.nom,al.cta,al.tel,al.sem);
		n++;
		if (n==21) { pausa();
			     for(i=7;i<=21;i++){
				gotoxy(1,ib);stri(80,' ');
				n=7;gotoxy(1,7);
			     }
		}

	     }; /*if*/
	   } /*while*/
	   pausa();
	  } /*else*/
	  goto consultas;

case '6': strcpy(rr,"CATALOGOS IMPRESOS");
	  encabezado(rr);
	  do {
	     gotoxy(1,7);
	     cputs("1) POR REGISTRO\r\n");
	     cputs("2) POR CUENTA\r\n");
	     cputs("3) POR NOMBRE\r\n");
	     cputs("4) POR SEMESTRE/CUENTA\r\n");
	     cputs("5) POR SEMESTRE/NOMBRE\r\n");
	     cputs("   OPCION ==>");rc=getche();
	     orden=rc-48;if (orden<0) orden=0;
	  }while (orden<0 || orden>5);
	  if (orden==0) break;
	  encabezado(rr);
	  do {
	     gotoxy(1,23);
	     cputs("ESTA LISTA SU IMPRESORA (S o N)?");
	     rc=getche();rc=upcase(rc);
	  }while (rc!='N' && rc!='S');
	  if (rc=='N') break; /* SALIDA DE CATALOGOS */

	  lc=0;pag=0;
	  gotoxy(1,23);cputs("IMPRESION EN PROCESO ...         ");

	  lar_buffer=208;no_llave=orden-1;buf_llave[0]=0;
	  st=BTRV(c_primer,pos,&al,&lar_buffer,buf_llave,no_llave);

	  while (st==0) {
	    if (lc==0 || lc>=60) {
	       if (lc>=60) {fprintf(stdprn,"%c",12);lc=0;}
	       strcpy(r,"PROGRAMA MUESTRA, TRABAJA UTILIZANDO EL MANEJADOR DE BASES DE DATOS DE BTRIEVE");

	       strip(40-strlen(r)/2,' ');fprintf(stdprn,"%s\n",r);
	       strcpy(r,"AGENDA DE ALUMNOS DE M.A.C., EN TURBO C V2.0");
	       strip(40-strlen(r)/2,' ');fprintf(stdprn,"%s\n",r);
	       if (orden==1) strcpy(rr,"No. DE REGISTRO");
	       if (orden==2) strcpy(rr,"No. DE CUENTA");
	       if (orden==3) strcpy(rr,"NOMBRE");
	       if (orden==4) strcpy(rr,"No. DE SEMESTRE Y CUENTA");
	       if (orden==5) strcpy(rr,"No. DE SEMESTRE Y NOMBRE");
	       strcpy(r,"REPORTE ORDENADO POR ");
	       strcat(r,rr);
	       strip(40-strlen(r)/2,' ');fprintf(stdprn,"%s\n",r);
	       pag++;fprintf(stdprn,"PAG:[%3d]\n",pag);
	       strip(80,'-');fprintf(stdprn,"\n");
	       fprintf(stdprn,"  REG CUENTA     NOMBRE                               SEM GEN   TELEFONO\n");
	       strip(80,'-');fprintf(stdprn,"\n");
	       lc=7;
	    }
	    fprintf(stdprn,"%5d %-10s %-37s %2d %-5s %-16s\n",al.reg,al.cta,al.nom,al.sem,al.gen,al.tel);
	    lc++;
	    lar_buffer=208;
	    st=BTRV(c_sigui,pos,&al,&lar_buffer,buf_llave,no_llave);
	  }; /*while*/
	  if (lc>0) fprintf(stdprn,"%c",12);
	  break; /* SALIDA DE CATALOGOS */
} /* switch */

if (op!='7') goto menu; /* REGRESO AL MENU PRINCIPAL*/

/* FIN DEL PROGRAMA */
st = BTRV(cerrar,pos,nada,&cero,nada,0);
if (st!=0) error_exit();
}



error_exit()
{
gotoxy(1,24);
printf("%s%4d%s","ERROR EN BTRIEVE No. ",st," PULSE ENTER PARA CONTINUAR.");
putch(7);
rc=getch();
if (st!=20) st = BTRV(restau,nada,nada,&cero,nada,0);
exit(0);
}


encabezado(rr)
char rr[256];
{
clrscr();
centra(1,"PROGRAMA MUESTRA, TRABAJA UTILIZANDO EL MANEJADOR DE BASES DE DATOS DE BTRIEVE");
centra(2,"AGENDA DE ALUMNOS DE M.A.C., EN TURBO C V2.0");
gotoxy(1,3);stri(80,'-');
color(0,7);centra(3,rr);color(7,0);
}

color(x,y)
char x,y;
{
textcolor(x);
textbackground(y);
}

centra(y,r)
char y,r[256];
{
if (y<=0) y=wherey();
gotoxy(40-strlen(r)/2,y);
cprintf("%s",r);
}

stri(n,c)
char n,c;
{
register int i;
for(i=1;i<=n;i++,putch(c));
}

strip(n,c)
char n,c;
{
register int i;
for(i=1;i<=n;i++,fprintf(stdprn,"%c",c));
}

pone_preg()
{
gotoxy(1,6);
cprintf("[1] CUENTA    :[%10s]\n\r","");
cprintf("[2] NOMBRE    :[%40s]\n\r","");
cprintf("[3] DIRECCION :[%40s]\n\r","");
cprintf("[4] COLONIA   :[%35s]\n\r","");
cprintf("[5] DEL O CIU :[%25s]\n\r","");
cprintf("[6] ESTADO    :[%25s]\n\r","");
cprintf("[7] TELEFONOS :[%16s]\n\r","");
cprintf("[8] GENERACION:[%05s]\n\r","");
cprintf("[9] SEMESTRE  :[%02s]\n\r","");
}

upcase(c)
char c;
{
if (c>='a' && c<='z') c=c-32;
return c;
}

pone_datos()
{
gotoxy(17, 6);puts(al.cta);
gotoxy(17, 7);puts(al.nom);
gotoxy(17, 8);puts(al.dir);
gotoxy(17, 9);puts(al.col);
gotoxy(17,10);puts(al.del);
gotoxy(17,11);puts(al.est);
gotoxy(17,12);puts(al.tel);
gotoxy(17,13);puts(al.gen);
gotoxy(17,14);cprintf("%2d",al.sem);
gotoxy(60, 4);cprintf("REGISTRO: [%5d]",al.reg);
}

pausa()
{
gotoxy(1,23);
cputs("PULSE [ENTER] PARA CONTINUAR ...");
rc=getch();
gotoxy(1,23);
stri(80,' ');
}
